dofile("const.lua")
dofile("menu.lua")

------------------------------------------------

function LoadScript(name)
	local f,e = openfile(name)
	if f then
		local s = f:read("*a")
		f:close()
		return s
	end
	showmsg(e)
	return ""
end

function GetActiveMemo()
	if ErrorMemo.Focused then
		return ErrorMemo
	end
	return ScriptMemo
end

function GetState(i)
	local t = {"Stopped.","Running...","Paused."}
	return t[1+Ctrl.GetState(i)]
end

------------------------------------------------

Version = "OpenEUO 0.9e"

MainForm = Obj.Create("TForm")
MainForm.Font.Name = "Courier New"
MainForm.Font.Size = 10
MainForm._ = {
	Width = 600,
	Height = 350,
	Caption = Version,
	Position = C.poScreenCenter,
	OnClose = function() Obj.Exit() end,
	Menu = Obj.Create("TMainMenu")
}
MainForm.Visible = true
BuildMenu(MainForm.Menu.Items,Menu)

MainPanel = Obj.Create("TPanel")
MainPanel.Align = C.alClient
MainPanel.Parent = MainForm

ScriptMemo = Obj.Create("TMemo")
ScriptMemo.Align = C.alClient
ScriptMemo.WantTabs = true
ScriptMemo.WordWrap = false
ScriptMemo.ScrollBars = 2
ScriptMemo.Parent = MainPanel
ScriptMemo.SetFocus()

ErrorMemo = Obj.Create("TMemo")
ErrorMemo.Height = 72
ErrorMemo.Align = C.alBottom
ErrorMemo.WantTabs = true
ErrorMemo.Parent = MainPanel

Splitter = Obj.Create("TSplitter")
Splitter.Align = C.alBottom
Splitter.Parent = MainPanel

BottomPanel = Obj.Create("TPanel")
BottomPanel.Height = 16
BottomPanel.Align = C.alBottom
BottomPanel.Parent = MainForm

BottomLabel = Obj.Create("TLabel")
BottomLabel.Font.Name = "Arial"
BottomLabel.Font.Size = 8
BottomLabel.Top = 1
BottomLabel.Left = 4
BottomLabel.Parent = BottomPanel

OpenDlg = Obj.Create("TOpenDialog")
OpenDlg.DefaultExt = "lua"
OpenDlg.InitialDir = getinstalldir().."scripts"
OpenDlg.Filter = "Lua Files (*.lua)|*.lua|Text Files (*.txt)|*.txt|All Files (*.*)|*.*"

if Ctrl.GetCount()==0 then Ctrl.Open() end
Ctrl.SetHandler(function(i)
	s = Ctrl.GetOutput(i)
	if s~="" then ErrorMemo.Lines.Add(s) end
	Ctrl.Unlock(i)
end)

Timer = Obj.Create("TTimer")
Timer.OnTimer = function()
	local y = ScriptMemo.GetLineFromChar(ScriptMemo.SelStart)
	local x = ScriptMemo.SelStart-ScriptMemo.GetLineIndex(y)
	BottomLabel.Caption = y+1 .. "," .. x+1 .. " | " .. GetState(0)
	Ctrl.Unlock(0)
	Ctrl.Lock(0)
end
Timer.Interval = 50

Obj.Loop()

Ctrl.Close(0)
Obj.Free(OpenDlg)
Obj.Free(ScriptMemo)
Obj.Free(MainForm)
