
Menu = {
	{"&File",00,{
		{"&New"        ,11       },
		{"&Open"       ,12       },
		{"-"           ,00       },
		{"&Exit"       ,13       },
	}},
	{"&Edit",00,{
		{"Cu&t"        ,21, 16472}, --CTRL-X
		{"&Copy"       ,22, 16451}, --CTRL-C
		{"&Paste"      ,23, 16470}, --CTRL-V
		{"&Delete"     ,24       },
		{"Select &All" ,25, 16449}, --CTRL-A
		{"-"           ,00       },
		{"&Undo"       ,26, 16474}, --CTRL-Z
	}},
	{"&Control",00,{
		{"&Start"      ,31, 00120}, --F9
		{"&Pause"      ,32       },
		{"&Stop"       ,33       },
	}},
	{"&Help",00,{
		{"&About"      ,41       },
	}},
}

------------------------------------------------

MenuHandler = {
	[11] = function()
			Ctrl.SetPrefix(0,"$")
			Ctrl.SetName(0,"noname")
			ScriptMemo.Clear()
	end,
	[12] = function()
		if OpenDlg.Execute() then
			Ctrl.SetPrefix(0,"!")
			Ctrl.SetName(0,OpenDlg.FileName)
			ScriptMemo.Lines.Text = LoadScript(OpenDlg.FileName)
		end
	end,
	[13] = function() Obj.Exit() end,

	[21] = function() GetActiveMemo().CutToClipboard() end,
	[22] = function() GetActiveMemo().CopyToClipboard() end,
	[23] = function() GetActiveMemo().PasteFromClipboard() end,
	[24] = function() GetActiveMemo().ClearSelection() end,
	[25] = function() GetActiveMemo().SelectAll() end,
	[26] = function() GetActiveMemo().Undo() end,

	[31] = function()
		ErrorMemo.Clear()
		Ctrl.SetScript(0,ScriptMemo.Lines.Text)
		Ctrl.SetState(0,1)
	end,
	[32] = function() Ctrl.SetState(0,2) end,
	[33] = function() Ctrl.SetState(0,0) end,
	[41] = function() showmsg(Version,"by Cheffe") end,
}

------------------------------------------------

function BuildMenu(parent,menu)
	local f = function(s)
		if MenuHandler[s.Tag] then
			MenuHandler[s.Tag]()
		end
	end
	for i = 1,#menu do
		local t = menu[i]
		local m = Obj.Create("TMenuItem")
		m.Caption = t[1]
		m.Tag = t[2]
		m.OnClick = f
		if type(t[3])=="table" then
			BuildMenu(m,t[3])
		end
		if type(t[3])=="number" then
			m.ShortCut=t[3]
		end
		parent.Add(m)
	end
end
